var Common = {
	
	corsremote : null,
	
	corsswf : null,
	
	crossAjax : null,
	
	onReady: function(){
		/*easyxdm*/
		Common.corsremote = 'http://dev.ibe.gridnine.com/cross_domain/cors/index.html';
		Common.corsswf = 'http://dev.ibe.gridnine.com/cross_domain_test/cors/easyxdm.swf';
		Common.crossAjax = new easyXDM.Rpc({
			remote: Common.corsremote,
			swf: Common.corsswf
		}, {
			remote: {
				request: {} // request is exposed by /cors/
			}
		});	
		
		/**/
		
		Common.initCalendar();
		Common.updateCalendar();
		Common.initAutocomplete();
		
		for (var i = 0; i < $('select[name="FlightSearchForm.children"]').val(); i++) {
			$('.child_age').eq(i).show()
		};
		if ($('select[name="FlightSearchForm.children"]').val() > 0) {
			$('.child_age_title').show();
		}
		$('select[name="FlightSearchForm.children"]').change(function(e) {
			$('.child_age').hide();
			$('.child_age_title').hide();
			if ($(e.target).val() > 0) {
				$('.child_age_title').show();
			}
			for (var i = 0; i < $(e.target).val(); i++) {
				$('.child_age').eq(i).show()
			};
		})
		
		/* Airlines */

		$('.airline').autocomplete({
			source: function( request, responseAutocomplete ) {
				var result = [];
				Common.crossAjax.request({
					url: 'http://dev.ibe.gridnine.com/system/modules/com.gridnine.opencms.modules.sabre-ibe/pages/ajax_provider_locations.jsp?cmd=GET_AIRLINES&locale=ru&term=' + request.term,
					method: "POST",
					data: {},
				}, function(response) {
					switch (response.status) {
						case 200:
							try {
								var data = JSON.parse(response.data);
								result = $.map(data, function(val) {
											return { value : val.value, label : val.label };
										}
								)
								responseAutocomplete(result);
							} catch (e) {
								alert('error' + e);
							}
							return result;
							break;
						default:
							alert('error');
							break;
					}
				});
				return result;
			},
			minLength: 0,
			focus: function(event, ui) {
				return false;
			},
			select: function(event, ui) {
				var $input = $('input[name="FlightSearchForm.airline.CODE"]');
				var airlines = $input.map(function(){
					return $(this).val();
				}).get();
				if(airlines.length >= 3){
					Common.showErrorDialog('     !');
				} else if ($.inArray(ui.item.value, airlines) != -1) {
					Common.showErrorDialog('    !');
				} else {
					if(airlines.length === 0){
						//$('#selected_airlines').toggle();
					}
					$('<div class="airline_block">'
					+ '	<div class="airline">' + ui.item.label + '</div>'
					+ '	<div id="' + ui.item.value + '" class="cross"></div>'
					+ '	<div class="clear"></div>'
					+ ' <input type="hidden" name="FlightSearchForm.airline.CODE" value="' + ui.item.value + '" />'
					+ '</div>').appendTo($('#airlines_list'));
					$('input[name="FlightSearchForm.airline"]').val('');
				}
				return false;
			}
		}).click(function(){
			$(this)
				.val("")
				.autocomplete("search");
		});
		
		$('#airlines_list').delegate('div.cross', 'click', function(){
			$(this).parent().remove();
			if($('input[name="FlightSearchForm.airline.CODE"]').length === 0){
				//$('#selected_airlines').toggle();
			}
		});
		
		$('#error_dialog').dialog({
			title: 'Ошибки',
			modal: true,
			width: 400,
			height: 400,
			autoOpen: false
		});

		$('#search_button').button().click(function(){
			return Common.doSearch(this);
		});

		window.setInterval(function () {
			var result = [];
				Common.crossAjax.request({
					url: 'http://dev.ibe.gridnine.com/system/modules/com.gridnine.opencms.modules.sabre-ibe/pages/ajax_provider_noop.jsp',
					method: "POST",
					data: {},
				}, function(response) {
					switch (response.status) {
						case 200:
							/* noop */
							break;
						default:
							alert('error');
							break;
					}
				});
				return result;
		}, 600000);

		var customizeControls = function() {
            var $adults = $('select[name="FlightSearchForm.adults"]');
			var $children = $('select[name="FlightSearchForm.children"]');
			var $infants = $('select[name="FlightSearchForm.infants"]');
			var $infantsWithSeat = $('select[name="FlightSearchForm.infants_with_seat"]');
			var $youths = $('select[name="FlightSearchForm.youths"]');
			var $seniors = $('select[name="FlightSearchForm.seniors"]');

			var $ordinaryErrorBlock = $('.ordinary_error_block');
			var $youthErrorBlock = $('.youth_error_block');
			var $seniorErrorBlock = $('.senior_error_block');

			var adultsNum = $adults.val();
			var childrenNum = $children.val();
			var infantsNum = $infants.val();
            var infantsWithSeatNum = $infantsWithSeat.val();

            var youthsNum = $youths.val();
            var seniorsNum = $seniors.val();

            var exceptYouths = youthsNum > 0;
            var exceptSeniors = seniorsNum > 0;
            var exceptOrdinary = adultsNum > 0;

            if (exceptYouths || exceptSeniors) {
                $adults.attr('disabled','disabled');
                $children.attr('disabled','disabled');
                $infants.attr('disabled','disabled');
                $infantsWithSeat.attr('disabled','disabled');

                addErrorBlock($ordinaryErrorBlock);
            } else {
                $adults.removeAttr('disabled');
                $children.removeAttr('disabled');
                $infants.removeAttr('disabled');
                $infantsWithSeat.removeAttr('disabled');

                removeErrorBlock($ordinaryErrorBlock);
            }
            if (exceptOrdinary || exceptSeniors){
                $youths.attr('disabled','disabled');

                addErrorBlock($youthErrorBlock);
            } else {
                $youths.removeAttr('disabled');

                removeErrorBlock($youthErrorBlock);
            }
            if (exceptYouths || exceptOrdinary){
                $seniors.attr('disabled','disabled');

                addErrorBlock($seniorErrorBlock);
            } else {
                $seniors.removeAttr('disabled');

                removeErrorBlock($seniorErrorBlock);
            }

			var max = 8;

			function addErrorBlock($errorBlock){
                $errorBlock.attr('title','  ""  ""      .')
                   .addClass('error').removeClass('no_display').tooltip();
			}

			function removeErrorBlock($errorBlock){
                $errorBlock.removeClass('error').addClass('no_display')
                    .tooltip('destroy')
                    .attr('title', '');
			}

			function updateSelect($select, max, selected){
				$($select.children()).remove();
				for(var i = 0; i <= max; i++){
					$select.append('<option value="' + i + '">' + i + '</option>');
				}
				$select.children("option[value='" + selected + "']").attr("selected", "selected");
			}

			updateSelect($adults, max - childrenNum - infantsWithSeatNum, adultsNum);
			updateSelect($children, max - adultsNum - infantsWithSeatNum, childrenNum);
			updateSelect($infants, adultsNum, infantsNum);
			updateSelect($infantsWithSeat, max - childrenNum - adultsNum, infantsWithSeatNum);
			
				updateSelect($youths, max, youthsNum);			
			
			
				updateSelect($seniors, max, seniorsNum);			
			
		};

		$('.passengers select').change(function() {
            customizeControls();
		});

		customizeControls();
	},
	
	/*used*/
	getFormInputsObjects: function ($form, filter) {
		var $inputs = $form.find('input[type=text], input[type=hidden], input[type=password], input[type=checkbox]:checked, input[type=radio]:checked, textarea, select');
		if(filter != undefined){
			$inputs = $inputs.filter(filter);
		}
		return $inputs;
	},
	
	/*used*/
	getFormInputs: function ($form, filter) {
		var $inputs = Common.getFormInputsObjects($form, filter);
		var result = {};
		$inputs.each(function() {
			result[this.name] = $(this).val() || '';
			/*result.push({
				'name' : this.name,
				'value' : $(this).val() || ''
			});*/
		});
		return result;
	},
	
	/*used*/
	initAutocomplete: function(){
		$('.route input').autocomplete({
			source: function( request, response ) {
				return Common.getLocations(request.term, response);
			},
			minLength: 0,
			focus: function(event, ui) {
				return false;
			},
			select: function(event, ui) {			
				$(this)
				.val(ui.item.label)
				.next()
				.val(ui.item.value);
				$(this).trigger('change');
				$(this).setSelection(0);
				return false;
			}
		}).click(function(){
			$(this)
			.val("")
			.next()
			.val("")
			.end()
			.autocomplete("search");
		});
	},

	getLocations: function(term, responseAutocomplete) {
		var result = [];
		Common.crossAjax.request({
			url: 'http://dev.ibe.gridnine.com/system/modules/com.gridnine.opencms.modules.sabre-ibe/pages/ajax_provider_locations.jsp?cmd=GET_LOCATIONS&locale=ru&term=' + term,
			method: "POST",
			data: {},
		}, function(response) {
			switch (response.status) {
				case 200:
					try {
						var data = JSON.parse(response.data);
						result = $.map(data, function(val) {
									return { value : val.value, label : val.label };
								}
						)
						responseAutocomplete(result);
					} catch (e) {
						alert('error' + e);
					}
					return result;
					break;
				default:
					alert('error');
					break;
			}
		});
		return result;
	},
	
	calendarSettings: {
		exludedDates :
		
		['1392840000000','1391976000000'],
		isSaturdayForbidden : false,
		isSundayForbidden : false,
		stopTime : null,
		dayShift : 0

	},

	initCalendar: function(){
		$.datepicker.setDefaults($.datepicker.regional['ru']);
		$('.calendar').each(function () {
			var cal = $(this);
			cal.datepicker({
				minDate: '0',
				dateFormat: 'dd.mm.yy',
				numberOfMonths: cal.hasClass('single_calendar') ? 1 : 2,
				onSelect: function(){
					Common.updateCalendar(this);
				},
				beforeShowDay: function(date) {
					var day = date.getDay();
					var isTime = false;
					var tomorrow = new Date();
					tomorrow.setDate(tomorrow.getDate() + 1);
					var ShiftDayDate = new Date();
					ShiftDayDate.setDate(ShiftDayDate.getDate() + Common.calendarSettings.dayShift - 3600000);
					var today = new Date();
					var msPerDay = 24 * 60 * 60 * 1000;
					var daysLeft = (today.getTime() - date.getTime()) / msPerDay;
					daysLeft = Math.round(Math.abs(daysLeft));
					if (Common.calendarSettings.isSaturdayForbidden) {
					 	if ((day == 6) && (daysLeft < 7)) {
					 		return [false];
					 	}
					}
					if (Common.calendarSettings.isSundayForbidden) {
						if ((day == 0) && (daysLeft < 7)) {
							return [false];
						}
					}
					for (var i = 0; i <= Common.calendarSettings.exludedDates.length; i++) {
						if (date.getTime() == Common.calendarSettings.exludedDates[i]){
							 return [false];
						}
					}
					for (var i = 0; i <= Common.calendarSettings.exludedDates.length; i++) {
						if ((today.getMonth() == date.getMonth())
								&& (today.getDate() == date.getDate())
								&& ((date.getTime() - Common.calendarSettings.exludedDates[i]) / msPerDay > -2)
								&& ((date.getTime() - Common.calendarSettings.exludedDates[i]) / msPerDay < 1)){
							isTime = true;
						}
					}
					if (Common.calendarSettings.stopTime != null) {
						if (today.getHours() > Common.calendarSettings.stopTime) {
							if (Common.calendarSettings.isSaturdayForbidden) {
								if ((date.getDay() == 6) && (today.getDay() == 5) && (daysLeft < 2)) {
									return [false];
								}
							}
							if (isTime) {
								return [false];
							}
						}
					}
					if (Common.calendarSettings.dayShift > 0) {
						if (date.getTime() <= ShiftDayDate.getTime()) {
							return [false];
						}
					}
					
					var calendarDiv = $('#ui-datepicker-div');
					if (calendarDiv.length > 0 && cal.hasClass('single_calendar') && !calendarDiv.hasClass('express_menu_iframe_ui_datepicker_div')) {
						calendarDiv.addClass('express_menu_iframe_ui_datepicker_div');
					}
					
					return [true];
				 }
			}).datepicker('widget').css('z-index', 200);
		});
				
		
		$('.calendarImage').click(function(){
			$(this).prev().datepicker('show');
		});
		$('.calendarImage2').click(function(){
			$(this).prev().datepicker('show');
		});
	},

	updateCalendar: function(element){
		if(element === undefined){
			var $firstCalendar = $(".calendar:first");
			if($firstCalendar.size() > 0){
				element = $firstCalendar.get(0);
			}
		} else {
			var before = true;
			var minDate = $(element).datepicker('getDate');
			$('.calendar', $(element).parents('.search_mode')).each(function(){
				if (!before) {
					$(this).datepicker("option", "minDate", minDate);
					if($(this).datepicker("getDate") <= minDate) {
						var nextDate = new Date(minDate);
						nextDate.setDate(nextDate.getDate() + 7);
						$(this).datepicker("setDate", nextDate);
					}
					return false;
				}
				if (this == element) {
					before = false;
				}
			});
		}
		jQuery(element).trigger('change');
	},
	
	postToUrl: function(path, params, method, target) {
	    method = method || "post"; // Set method to post by default, if not specified.

	    // The rest of this code assumes you are not using a library.
	    // It can be made less wordy if you use one.
	    var form = document.createElement("form");
	    form.setAttribute("method", method);
	    form.setAttribute("action", path);
	    if (target != null) {
	    	form.setAttribute("target", target);
	    } 

	    for(var key in params) {
	        var hiddenField = document.createElement("input");
	        hiddenField.setAttribute("type", "hidden");
	        hiddenField.setAttribute("name", key);
	        hiddenField.setAttribute("value", params[key]);

	        form.appendChild(hiddenField);
	    }

	    document.body.appendChild(form);
	    form.submit();
	},
	
	/*used*/
	validateSearch: function() {
		var returnSense = true;
		$departure = $('input[name="FlightSearchForm.departureLocation.0"]:visible');
		$arrival = $('input[name="FlightSearchForm.arrivalLocation.0"]:visible');
		$dates = $('input[name^="FlightSearchForm.date"]:visible');
		if($departure.val() == "") 
		{
			$departure.attr('title','  ')
			.addClass('error')
			.tooltip()
			.focus()
			.change(function(){
				$(this)
				.removeClass('error')
				.tooltip('destroy')
				.attr('title', '');
			});
			returnSense = false;
			return false;
		}	
		else if($arrival.val() == "") 
		{
			$arrival.attr('title','  ')
			.addClass('error')
			.tooltip()
			.focus()
			.change(function(){
				$(this)
				.removeClass('error')
				.tooltip('destroy')
				.attr('title', '');
			});
			returnSense = false;
			return false;
		} else if($dates.length > 0) {
			var i = 0;
			$dates.each(function() {
				$this = jQuery(this);
				var arrival = $('input[name="FlightSearchForm.arrivalLocation.' + i + '"]:visible');
				var departure = $('input[name="FlightSearchForm.departureLocation.' + i + '"]:visible');
				if($this.val() == "" && departure.val() != '' && arrival.val() != '') {
					$this.attr('title','Заполните дату')
					.addClass('error')
					.tooltip()
					.focus()
					.change(function(){
						$(this)
						.removeClass('error')
						.tooltip('destroy')
						.attr('title', '');
					});
					returnSense = false;
					return false;
				}	
				i++;
			});			
		}
		return returnSense;
	},
	
	/*used*/
	doSearch: function(button) {
		if(!Common.validateSearch()) return false;
		var $button = $(button);
		$button.button("disable");
		var request = Common.getFormInputs($('form[name="avia_booking_form"]'), function(){
			var mode = $(this).parents(".search_mode");
			if(mode.size() == 1){
				if($('input[name="FlightSearchForm.routeType"]:checked').val() == 'MULTISTOP'){
					return mode.hasClass("multistop_search");
				} else {
					return mode.hasClass("simple_search");
				}
			}
			return true;
		});
		request['cmd'] = 'VALIDATE_STEP_1';
		
		Common.crossAjax.request({
			url: 'http://dev.ibe.gridnine.com/system/modules/com.gridnine.opencms.modules.sabre-ibe/pages/ajax_provider_avia.jsp',
			method: "POST",
			data: request,
		}, function(response) {
			switch (response.status) {
				case 200:
					try {
						var data = JSON.parse(response.data);
						if (data.status == 'success') {
							var windowWidth = $(window).width() > 1024 ? "wide" : "default";
							if ($button.hasClass('parent_window')) {
								Common.postToUrl('http://dev.ibe.gridnine.com/ru/step2.html' + '?screen=' + windowWidth + '&' + data.route, {}, 'POST', '_parent');
							} else if ($button.hasClass('new_window')) {
								Common.postToUrl('http://dev.ibe.gridnine.com/ru/step2.html' + '?screen=' + windowWidth + '&' + data.route, {}, 'POST', '_new');
							} else {
								location.href = 'http://dev.ibe.gridnine.com/ru/step2.html' + '?screen=' + windowWidth + '&' + data.route;
							}
							$button.button("enable");
						} else if (data.status == 'errors') {
							Common.showErrors(data.errors);
							$button.button("enable");
						} else {
							alert('Ошибка сервера')
						}
					} catch (e) {
						alert('error' + e);
					}
					break;
				default:
					alert('error');
					break;
			}
		});
		
		return false;
	},
	
	showCommonErrorsDialog: function(content, withRootRedirect) {
		
		var dialogTitle = '  ';
		var closeButtonText = '';
		$("#error_dialog").html(content).dialog({
		      
			  title: dialogTitle,
			  resizable: true,
		      height:340,
		      modal: true,
		      width: 600,
		      buttons: [{
		    	  
		    	  text: closeButtonText,
		          "id": "btnOk",
		          click: function () {

		        	  if (withRootRedirect && withRootRedirect === true) {
		        		  location.href = "/";
		        	  }
			          
			          $( this ).dialog( "close" );
		          },		    	  
		      }]
		}).dialog("open");	
	},

	showErrors: function(errors) {
		var common = [];
		for (var error in errors) {
			var $input;
			if (/\.-1$/ig.test(error)) {
				$input = $('[name="' + error.substring(0, error.length - 3) + '"]:input:visible');
			} else {
				$input = $('[name="' + error + '"]:input:visible');
			}
			if(!$input.size()) {
				if($.inArray(errors[error], common) === -1) {
					common.push(errors[error]);
				}
			} else {
				$input
					.attr('title', errors[error])
					.addClass('error')
					.tooltip()					
					.change(function(){
						$(this)
							.removeClass('error')
							.tooltip('destroy')
							.attr('title', '');
					});
				$('.error:first').focus();
			}
		}
		if (common.length) {
			Common.showErrorDialog(common);
		}
	},
	newDate : function(day, month, year) {
		var result = new Date();
		result.setFullYear(year, month, day);
		return result;
	},
	getAge : function(date, currentDate) {
		if (date == null) return 0;
		var gc1 = new Date();
		gc1.setTime(date.getTime());
		var gc2 = new Date();
		gc2.setTime(currentDate.getTime());
		var years = gc2.getFullYear() - gc1.getFullYear();
		if (gc2.getMonth() < gc1.getMonth()) years --;    	
		if (gc2.getMonth() == gc1.getMonth() &&
			gc2.getDate() < gc1.getDate()) years --;
			if (years.isNan) {
				return 0;
			}
		return years;
	}, 
	addYearsToDate : function(date, value) {
		date.setFullYear(date.getFullYear() + value);
		return date;
	}
	,
	fillExpiredDate : function(container_name, birthday_idx, expired_idx) {
		var doctype_field_name = 'AviaBookingForm.psgr.documentType.' + expired_idx;
		var docType = $(container_name + 'select[name="' + doctype_field_name + '"] option:selected');
		var that = $(container_name + 'select[name="' + doctype_field_name + '"]');
		var exp_field_name = 'AviaBookingForm.psgr.passportExpired.' + expired_idx;
		var exp_day = $(container_name + 'select[name="' + exp_field_name + '.DAY"]');
		var exp_month = $(container_name + 'select[name="' + exp_field_name + '.MONTH"]');
		var exp_year = $(container_name + 'select[name="' + exp_field_name + '.YEAR"]');
		exp_day.find('option:first').attr('selected', true);
		exp_month.find('option:first').attr('selected', true);
		exp_year.find('option:first').attr('selected', true);
		if (docType.val() == 'INTERNAL' || docType.val() == 'BIRTHDAY_NOTIFICATION') {
			var birthday_field_name = 'AviaBookingForm.psgr.birthday.' + birthday_idx;
			var day = $(container_name + 'select[name="' + birthday_field_name + '.DAY"] option:selected');
			var month = $(container_name + 'select[name="' + birthday_field_name + '.MONTH"] option:selected');
			var year = $(container_name + 'select[name="' + birthday_field_name + '.YEAR"] option:selected');
			var bdContainer = $(container_name + ' input[name="birth-day.' + expired_idx + '"]');
			var birthDay = bdContainer.length == 1 ? Common.newDate(bdContainer.data('day'), bdContainer.data('month'), bdContainer.data('year')) : Common.newDate(day.val(), month.val(), year.val());
			var age = Common.getAge(birthDay, new Date());
			var expire_date = new Date();
			if (bdContainer.length == 1 && (docType.val() === 'INTERNAL' || docType.val() === 'BIRTHDAY_NOTIFICATION')) {
				expire_date = Common.addYearsToDate(birthDay, 50);
			} else if (age < 20) {
				expire_date = Common.addYearsToDate(birthDay, 20);
			} else if (age < 45) {
				expire_date = Common.addYearsToDate(birthDay, 45);
			} else {
				expire_date = Common.addYearsToDate(birthDay, 100);
			}
			var tar_exp_day = exp_day.find('option[value="' + expire_date.getDate() + '"]');
			var tar_exp_month = exp_month.find('option[value="' + expire_date.getMonth() + '"]');
			var tar_exp_year = exp_year.find('option[value="' + expire_date.getFullYear() + '"]');
			if (tar_exp_day.length > 0) {
				tar_exp_day.attr('selected', true);
			}
			if (tar_exp_month.length > 0) {
				tar_exp_month.attr('selected', true);
			}
			if (tar_exp_year.length > 0) {
				tar_exp_year.attr('selected', true);
			}
			if (that.length > 0) {
				that.parents('.panel').find('[name^="AviaBookingForm.psgr.passportExpired.' + that.attr('name').replace(/(.*)\./, '') + '"]').each(function() {
					$(this).parent('.right_block').hide();
					$(this).parent('.right_block').prev().hide();
				});
			}
		} else {
			if (that.length > 0) {
				that.parents('.panel').find('[name^="AviaBookingForm.psgr.passportExpired.' + that.attr('name').replace(/(.*)\./, '') + '"]').each(function() {
					$(this).parent('.right_block').show();
					$(this).parent('.right_block').prev().show();
				});
			}
		}
	},

	isCompositeDate: function(fieldName) {
		if (fieldName.indexOf('.DAY') > -1 || fieldName.indexOf('.MONTH') > -1 || fieldName.indexOf('.YEAR') > -1) {
			return true;
		}
		return false;
	},

	getCompositeDateFields: function(field) {
		if (field && field.attr('idx')) {
			var fieldIndex = field.attr('idx');
			var fieldName = field.attr('name');
			fieldName= fieldName.replace('.' + fieldIndex + '.DAY', '').replace('.' + fieldIndex + '.MONTH', '').replace('.' + fieldIndex + '.YEAR', '');
			return $('[name="' + fieldName + '.' + fieldIndex + '.DAY"]').add($('[name="' + fieldName + '.' + fieldIndex + '.MONTH"]')).add($('[name="' + fieldName + '.' + fieldIndex + '.YEAR"]'));
		}
		return field;
	},

	displayErrors: function(fields, errors) {
		var common = [];
		fields.each(function() {
			var field = $(this);
			for (fname in errors) {
				if (field.attr('name') == fname) {
					field
					.attr('title', errors[fname])
					.addClass('error')
					.tooltip()
					.change(function(){
						$(this)
							.removeClass('error')
							.tooltip('destroy')
							.attr('title', '');
					});
				}
			}
		});
	},

	hideErrors: function(fields) {
		fields.each(function() {
			var field = $(this);
			if(field.hasClass('error')){
				field.removeClass('error').tooltip('destroy');
			}
		});
	},

	showErrorDialog: function(errors){
		var errorText;
		if(Object.prototype.toString.call(errors) === '[object String]') {
			errorText = errors;
		} else {
			var errorText = $('<ul>');
			$.each(errors, function(){
				if(typeof(this.name) != "undefined")
				{
					errorText.append($('<li>' + this.name + '</li>'));
				}
				else
				{
					errorText.append($('<li>' + this + '</li>'));
				}
			});
		}
		$("#error_dialog").html(errorText).dialog('open');
	},
	
};



$(function() {
	Common.onReady();
});
   (function ($) {

   	  jQuery.fn.setSelection = function(selectionStart, selectionEnd) {
   	    if(this.lengh == 0) return this;
   	    input = this[0];
   	 
   	    if (input.createTextRange) {
   	      var range = input.createTextRange();
   	      range.collapse(true);
   	      range.moveEnd('character', selectionEnd);
   	      range.moveStart('character', selectionStart);
   	      range.select();
   	    } else if (input.setSelectionRange) {
   	      input.focus();
   	      input.setSelectionRange(selectionStart, selectionEnd);
   	    }
   	 
   	    return this;
   	  }
   })(jQuery);